//Strings.h                         Class Declaration For String Class So Far
#if !defined(STRINGS_H)             //This is an inclusion guard to guard against other
#define STRINGS_H                   //files that may previously included this file.
#define EXPANSION_FACTOR      2     //This is the factor to anticipate future space needs
#define MINIMUM_ALLOCATION    8     //Allocations will be at least this number

class String
{
  public:
  String();                         //Uninitialized Constructor - Does nothing
  String(const char);               //Constructor Initializes String With char
  String(const char*);              //Constructor Initializes String With char*
  String(const String&);            //Constructor Initializes String With Another String (Copy Constructor)
  String& operator=(const char);    //Operator= for assigning char to String
  String& operator=(const char*);   //Operator= for assigning literal or char* to String 
  String& operator=(const String&); //Operator= for assigning 2nd String to 1st
  String& operator+(const char);    //Operator+ for adding char to String
  String& operator+(const char*);   //Operator+ for adding char* to String (char* Points To Null Terminated Ascii String Array
  String& operator+(const String&); //Operator+ for adding Another String To The String
  int LenStr(void);                 //Returns the length of what's pointed to by pStrBuffer
  char* lpStr(void);                //Returns Address of String data Member  >> this->lpStr() 
  ~String();                        //String Destructor
  
  private:
  char* pStrBuffer;                 //This char* member holds the address of an allocated String
  int   iAllowableCharacterCount;   //Max number of chars that will fit in presently allocated buffer
};
#endif
